from datetime import datetime, date, time
import sys
import os
import shutil
import io
import argparse
import random
import math
from copy import deepcopy
import glob
import re
    
## extracts the data
def run(infile_name, outfile_name):
  if (not infile_name.endswith(".mzXML")):
    raise Exception ("infile has no .mzXML suffix");
  if (outfile_name==None):
    outfile_name = infile_name.replace(".mzXML", "_fixed.mzXML")
  print "infile: ", infile_name
  print "outfile: ", outfile_name
  
  ## parse the file:
  f = open(infile_name, 'r')
  c_wholefile = f.read()
  f.close()
  
  count = 0
  (c_wholefile, count) = re.subn(r'</peaks>\n  <scan', r'</peaks>\n  </scan>\n  <scan', c_wholefile) 
  
  print count, " missing tags inserted"
  (c_wholefile, count) = re.subn(r'</scan>\n  </scan>', r'</scan>', c_wholefile) 
  
  print count, " excess tags removed"


  ## fix MS level number:
  #(c_wholefile, count) = re.subn(r'(?s)(<scan.*?msLevel=)"2"(.*?retentionTime="PT\d*S".*?</scan>)', r"\1\"1\"\2", c_wholefile) 
  #print count, " ms levels corrected"
  
  f = open(outfile_name, 'w')
  f.write(c_wholefile)
  f.close()
  
  
  
  
  
## // end run()  

if __name__ == "__main__":

    parser = argparse.ArgumentParser(description='Fix mzXML generated by ETISEQ',
             formatter_class=argparse.RawDescriptionHelpFormatter,
				)
    parser.add_argument('infile', action='store', help='File by ETISEQ (broken)')
    parser.add_argument('--outfile', action='store', help='name of fixed file (defaults to "<infile_prefix>_fixed.mzXML")')

    args = parser.parse_args()
    
    run( args.infile, args.outfile )