## parse annotated pepXML's into a more managable format

from datetime import datetime, date, time
import sys
import os
import shutil
#import io
import argparse
import random
import math
from copy import deepcopy
import glob
import re
    
## extracts the data
def run(infile_name):
  
  ## parse the file:
  f = open(infile_name, 'r')
  c_wholefile = f.read()
  f.close()

  if (not infile_name.endswith(".pepXML")):
    raise Exception ("infile has no .pepXML suffix");
  
  outfile_name = infile_name.replace(".pepXML", "_fixed.pepXML")
  basename = infile_name.replace(".pepXML", "")
  print "infile: ", infile_name
  print "outfile: ", outfile_name

  
  fixed_string = re.sub(r'base_name=".*?"', 'base_name="' + basename + '"', c_wholefile)
  
  ## write result
  f = open(outfile_name, 'w')
  f.write(fixed_string)
  f.close()
  
  
  
  
  
## // end run()  

if __name__ == "__main__":

    parser = argparse.ArgumentParser(description='Fix basename of mzML file in pepXML',
             formatter_class=argparse.RawDescriptionHelpFormatter,
				)
    parser.add_argument('infile', action='store', help='File by our TOPPAS converter')

    args = parser.parse_args()
    
    run( args.infile)

